%global srcname camlbz2

Name:           ocaml-%{srcname}
Version:        0.7.0
Release:        2%{?dist}
Summary:        OCaml bindings for bzip2

# The usual OCaml linking exception applies
License:        LGPLv2+ with exceptions
URL:            https://gitlab.com/irill/camlbz2
Source0:        %{url}/-/archive/%{version}/%{srcname}-%{version}.tar.gz
# Generate useful debuginfo
Patch0:         %{name}-debuginfo.patch
# Use Stdlib instead of the deprecated Pervasives
Patch1:         %{name}-pervasives.patch
# Make the C code const-correct
# https://gitlab.com/irill/camlbz2/-/merge_requests/1
Patch2:         %{name}-const.patch
# Unbundle the OCaml io.h header file
Patch3:         %{name}-io-h.patch

BuildRequires:  automake
BuildRequires:  make
BuildRequires:  ocaml
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-ocamldoc
BuildRequires:  pkgconfig(bzip2)

%description
This package contains OCaml bindings for bzip2.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       bzip2-devel%{?_isa}

%description    devel
The %{name}-devel package contains libraries and signature
files for developing applications that use %{name}.

%prep
%autosetup -n %{srcname}-%{version} -p1

# Generate the configure script
autoreconf -fi -I .

# Make sure we don't use the bundled copy of io.h
rm io.h

%build
%configure
# FIXME: parallel builds often fail due to missing dependencies
make
make doc

%install
# %%make_install sets the wrong DESTDIR
export OCAMLFIND_DESTDIR=%{buildroot}%{_libdir}/ocaml
mkdir -p $OCAMLFIND_DESTDIR/stublibs
make install DESTDIR=$OCAMLFIND_DESTDIR INSTALL='%{_bindir}/install -p'

# This does not work because it requires a missing test.ml file
#%%check
#make test

%files
%doc BUGS ChangeLog README
%license COPYING LICENSE
%dir %{_libdir}/ocaml/bz2
%{_libdir}/ocaml/bz2/META
%{_libdir}/ocaml/bz2/bz2.cma
%{_libdir}/ocaml/bz2/bz2.cmi
%{_libdir}/ocaml/stublibs/dllcamlbz2.so
%{_libdir}/ocaml/stublibs/dllcamlbz2.so.owner

%files devel
%doc doc/*
%{_libdir}/ocaml/bz2/*.a
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/bz2/bz2.cmxa
%{_libdir}/ocaml/bz2/bz2.cmx
%endif
%{_libdir}/ocaml/bz2/bz2.mli

%changelog
* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Fri Apr 16 2021 Jerry James <loganjerry@gmail.com> - 0.7.0-1
- Initial package
